/*ht1632matrixled.c*/

#include "ht1632matrixled.h"

//struct "object" of the whole display
extern struct MatrixDisplay theDisplay;

//define a swap function
#define swap(a, b) {uint16_t t=a;a=b;b=t;}

void HT1632LEDMatrix1(uint8_t data, uint8_t wr, uint8_t cs1,int8_t rd){
	theDisplay.matrices[0]= (struct HT1632*)malloc(sizeof(struct HT1632));

	theDisplay.matrices[0]=ht1632Init(data,wr,cs1,rd);
	theDisplay.matrixNum=1;
	theDisplay._width=24*theDisplay.matrixNum;
	theDisplay._height=16;


}//end "object" creation for one panel

void HT1632LEDMatrix2(uint8_t data, uint8_t wr, uint8_t cs1, uint8_t cs2,int8_t rd){
    theDisplay.matrices[0]= (struct HT1632*)malloc(sizeof(struct HT1632));
	theDisplay.matrices[1]= (struct HT1632*)malloc(sizeof(struct HT1632));

	theDisplay.matrices[0]=ht1632Init(data,wr,cs1,rd);
	theDisplay.matrices[1]=ht1632Init(data,wr,cs2,rd);
	theDisplay.matrixNum=2;
	theDisplay._width=24*theDisplay.matrixNum;
	theDisplay._height=16;
;

}//end "object" creation for two panels
void HT1632LEDMatrix3(uint8_t data, uint8_t wr, uint8_t cs1, uint8_t cs2, uint8_t cs3,int8_t rd){
    theDisplay.matrices[0]= malloc(sizeof(struct HT1632));
	theDisplay.matrices[1]= malloc(sizeof(struct HT1632));
	theDisplay.matrices[2]= malloc(sizeof(struct HT1632));

	theDisplay.matrices[0]=ht1632Init(data,wr,cs1,rd);
	theDisplay.matrices[1]=ht1632Init(data,wr,cs2,rd);
	theDisplay.matrices[2]=ht1632Init(data,wr,cs3,rd);
	theDisplay.matrixNum=3;
	theDisplay._width=24*theDisplay.matrixNum;
	theDisplay._height=16;



}//end "object" creation for three panels



void displayBegin(uint8_t type){
	for(uint8_t i=0;i<theDisplay.matrixNum;i++){
	
		//initialize each panel
		begin(type,theDisplay.matrices[i]);	

	}//end for	
}//end display begin


void displayClearScreen(void){
	for(uint8_t i=0; i<theDisplay.matrixNum;i++){

		clearScreen(theDisplay.matrices[i]);	

	}//end for

}//end display clear screen

void displayFillScreen(void){
	for(uint8_t i=0;i<theDisplay.matrixNum;i++){
	
		fillScreen(theDisplay.matrices[i]);
	
	}//end for

}//end display fill screen


void displayBlink(bool b){
	for(uint8_t i=0;i<theDisplay.matrixNum;i++){

		blink(b,theDisplay.matrices[i]);

    }//end for

}//end display blink


void displaySetBrightness(uint8_t brightness){
		for(uint8_t i=0;i<theDisplay.matrixNum;i++){
			setBrightness(brightness,theDisplay.matrices[i]);
        }//end for
}//end display set brightness


void displayWriteScreen(){
	for(uint8_t i=0;i<theDisplay.matrixNum;i++){
		writeScreen(theDisplay.matrices[i]);
    }//end for
}//end display write screen


uint8_t displayWidth(){
	return theDisplay._width;
}//end display width


uint8_t displayHeight(){
	return theDisplay._height;
}//end display height



//turn off single led(pixel)
void displayClearPixel(uint8_t x, uint8_t y){
	displayDrawPixel(x,y,1);
}//end display clear pixel

//turn on single led(pixel)
void displaySetPixel(uint8_t x, uint8_t y){
	displayDrawPixel(x,y,0);
}//end display set pixel

void displayDrawPixel(uint8_t x, uint8_t y, uint8_t color){
  if(y >= theDisplay._height) return;
  if(x >= theDisplay._width) return;

  uint8_t m;
  // figure out which matrix controller it is
  m = x / 24;
  x %= 24;

  uint16_t i;

  if (x < 8) {
    i = 7;
  } else if (x < 16) {
    i = 128 + 7;
  } else {
    i = 256 + 7;
  }
  i -= (x % 8);

  if (y < 8) {
    y *= 2;
  } else {
    y = (y-8) * 2 + 1;
  } 

  i += y * 8;

  if(color){ 
    setPixel(i,theDisplay.matrices[m]);
  }//end if
  else{
    clrPixel(i,theDisplay.matrices[m]);
  }//end else

}//end display draw Pixel


void displayDrawLine(int8_t x0, int8_t y0, int8_t x1, int8_t y1, uint8_t color){

  uint16_t steep = abs(y1 - y0) > abs(x1 - x0);
  if (steep) {
    swap(x0, y0);
    swap(x1, y1);
  }

  if (x0 > x1) {
    swap(x0, x1);
    swap(y0, y1);
  }

  uint16_t dx, dy;
  dx = x1 - x0;
  dy = abs(y1 - y0);

  int16_t err = dx / 2;
  int16_t ystep;

  if (y0 < y1) {
    ystep = 1;
  } else {
    ystep = -1;}

  for (; x0<=x1; x0++) {
    if (steep) {
      displayDrawPixel(y0, x0, color);
    } else {
      displayDrawPixel(x0, y0, color);
    }
    err -= dy;
    if (err < 0) {
      y0 += ystep;
      err += dx;
    }
  }

}//end draw Line

void displayDrawRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t color){
  displayDrawLine(x, y, x+w-1, y, color);
 
  displayDrawLine(x, y+h-1, x+w-1, y+h-1, color);

  displayDrawLine(x, y, x, y+h-1, color);

  displayDrawLine(x+w-1, y, x+w-1, y+h-1, color);

}//end display draw rectangle

void displayFillRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t color){

 for (uint8_t i=x; i<x+w; i++) {
    for (uint8_t j=y; j<y+h; j++) {
      displayDrawPixel(i, j, color);
    }
  }


}//end display fill rect

void displayDrawCircle(uint8_t x0, uint8_t y0, uint8_t r, uint8_t color){

  int16_t f = 1 - r;
  int16_t ddF_x = 1;
  int16_t ddF_y = -2 * r;
  int16_t x = 0;
  int16_t y = r;

  displayDrawPixel(x0, y0+r, color);
  displayDrawPixel(x0, y0-r, color);
  displayDrawPixel(x0+r, y0, color);
  displayDrawPixel(x0-r, y0, color);

  while (x<y) {
    if (f >= 0) {
      y--;
      ddF_y += 2;
      f += ddF_y;
    }
    x++;
    ddF_x += 2;
    f += ddF_x;
  
    displayDrawPixel(x0 + x, y0 + y, color);
    displayDrawPixel(x0 - x, y0 + y, color);
    displayDrawPixel(x0 + x, y0 - y, color);
    displayDrawPixel(x0 - x, y0 - y, color);
    
    displayDrawPixel(x0 + y, y0 + x, color);
    displayDrawPixel(x0 - y, y0 + x, color);
    displayDrawPixel(x0 + y, y0 - x, color);
    displayDrawPixel(x0 - y, y0 - x, color);
    
  }


}//end draw circle

void displayFillCircle(uint8_t x0, uint8_t y0, uint8_t r, uint8_t color){
  int16_t f = 1 - r;
  int16_t ddF_x = 1;
  int16_t ddF_y = -2 * r;
  int16_t x = 0;
  int16_t y = r;

  displayDrawLine(x0, y0-r, x0, y0+r+1, color);

  while (x<y) {
    if (f >= 0) {
      y--;
      ddF_y += 2;
      f += ddF_y;
    }
    x++;
    ddF_x += 2;
    f += ddF_x;
  
    displayDrawLine(x0+x, y0-y, x0+x, y0+y+1, color);
    displayDrawLine(x0-x, y0-y, x0-x, y0+y+1, color);
    displayDrawLine(x0+y, y0-x, x0+y, y0+x+1, color);
    displayDrawLine(x0-y, y0-x, x0-y, y0+x+1, color);
  }
}//end fill circle

void displaySetCursor(uint8_t x, uint8_t y){
	theDisplay.cursor_x=x;
	theDisplay.cursor_y=y;
}//end display set Cursor

void displaySetTextSize(uint8_t s){
	theDisplay.textsize=s;
}//end display set text size

void displaySetTextColor(uint8_t c){
	theDisplay.textcolor=c;
}//end display set text color

void displayWrite(uint8_t c){
  if (c == '\n') {
    	theDisplay.cursor_y += theDisplay.textsize*8;
    	theDisplay.cursor_x = 0;
  }//end if 
  else if (c == '\r') {
    // skip em
  } //end else if
  else {
    displayDrawChar(theDisplay.cursor_x, theDisplay.cursor_y, c, theDisplay.textcolor, theDisplay.textsize);
    theDisplay.cursor_x += theDisplay.textsize*6;
  }//end else

}//end display write

void displayDrawChar(uint8_t x, uint8_t y, char c, uint16_t color, uint8_t size){
	for(uint8_t i =0; i<5; i++ ) {
    
		uint8_t line = pgm_read_byte(font+(c*5)+i);
      
	  for(uint8_t j = 0; j<8; j++) {
    
	  	 if(line & 0x1){
	
		 	if(size == 1){ // default size
	     		displayDrawPixel(x+i, y+j, color);
			}//end 2nd if
	     	
			else {  // big size
	  			displayFillRect(x+i*size, y+j*size, size, size, color);
			} //end else
      	
		}//end first if
      
	  //move on to next line of char
	  line >>= 1;
    
	}//end 2nd for
  
  }//end first for

}//end display draw char

void displayDrawBitmap(uint8_t x, uint8_t y, const uint8_t *bitmap, uint8_t w, uint8_t h,uint8_t color){
  for (uint8_t j=0; j<h; j++) {
   
    for (uint8_t i=0; i<w; i++ ) {
   
      if (pgm_read_byte(bitmap + i + (j/8)*w) & (1<<(j%8))) {

			displayDrawPixel(x+i, y+j, color);

      }//end if

    }//end 2nd for

  }//end first for

}//end display draw bitmap

void displayFreeMemory(){
    for(uint8_t i=0;i<theDisplay.matrixNum;i++){

		free(theDisplay.matrices[i]);

    }//end for

}//end display Free Memory
