/*ht1632matrixled*/

#ifndef ht1632matrixled_h
#define ht1632matrixled_h

#include "ht1632.h"

//panel "object"
struct MatrixDisplay {
  struct HT1632* matrices[3];
  uint8_t matrixNum;
  uint8_t _width;
  uint8_t _height;
  uint8_t cursor_x;
  uint8_t cursor_y;
  uint8_t textsize;
  uint8_t textcolor;

};

//struct "object" of the whole display
struct MatrixDisplay theDisplay;

/*****************************************************
*HT1632 MATRIX LED FUNCTIONS
*****************************************************/

//initialize correct structs(depends on number of panels)
void HT1632LEDMatrix1(uint8_t data, uint8_t wr, uint8_t cs1, int8_t rd);
void HT1632LEDMatrix2(uint8_t data, uint8_t wr, uint8_t cs1, uint8_t cs2,int8_t rd);
void HT1632LEDMatrix3(uint8_t data, uint8_t wr, uint8_t cs1, uint8_t cs, uint8_t cs3,int8_t rd);

//Initialize the display functionality
void displayBegin(uint8_t type);
void displayClearScreen(void);
void displayFillScreen(void);
void displayBlink(bool b);
void displaySetBrightness(uint8_t brightness);
void displayWriteScreen();
uint8_t displayWidth();
uint8_t displayHeight();

//set and clear pixels
void displayClearPixel(uint8_t x, uint8_t y);
void displaySetPixel(uint8_t x, uint8_t y);
void displayDrawPixel(uint8_t x, uint8_t y, uint8_t color);

//draw and fill shapes
void displayDrawLine(int8_t x0, int8_t y0, int8_t x1, int8_t y1, uint8_t color);
void displayDrawRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t color);
void displayFillRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h, uint8_t color);
void displayDrawCircle(uint8_t x0, uint8_t y0, uint8_t r, uint8_t color);
void displayFillCircle(uint8_t x0, uint8_t y0, uint8_t r, uint8_t color);

  // Printing
void displaySetCursor(uint8_t x, uint8_t y);
void displaySetTextSize(uint8_t s);
void displaySetTextColor(uint8_t c);

void displayWrite(uint8_t c);

void displayDrawChar(uint8_t x, uint8_t y, char c, uint16_t color, uint8_t size);
void displayDrawBitmap(uint8_t x, uint8_t y, const uint8_t *bitmap, uint8_t w, uint8_t h,uint8_t color);

void displayFreeMemory();

#endif
