/*ledmatrixpanel.c*/

#include "ht1632.h"
#include "ht1632matrixled.h"
#include "delay.h"

int main(void){

/* 
This is a basic demo program showing how to write to a HT1632
These can be used for up to 16x24 LED matrix grids, with internal memory
and using only 3 pins - data, write and select.
Multiple HT1632's can share data and write pins, but need unique CS pins.
*/
/*
#define DATA 2
#define WR 3
#define CS 4

HT1632 matrix = HT1632(DATA, WR, CS);

void setup() {
  Serial.begin(9600);
  matrix.begin(HT1632_COMMON_16NMOS);
  
  delay(100);
  matrix.clearScreen();

}

void testMatrix(HT1632 matrix) {
  for (int i=0; i<24*16; i++) {
    matrix.setPixel(i);
    matrix.writeScreen();
  }
  
  // blink!
  matrix.blink(true);
  delay(2000);
  matrix.blink(false);
  
  // Adjust the brightness down 
  for (int8_t i=15; i>=0; i--) {
   matrix.setBrightness(i);
   delay(100);
  }
  // then back up
  for (uint8_t i=0; i<16; i++) {
   matrix.setBrightness(i);
   delay(100);
  }

  // Clear it out
  for (int i=0; i<24*16; i++) {
    matrix.clrPixel(i);
    matrix.writeScreen();
  }
}

void loop() {
  testMatrix(matrix);
}
*/
/**************************
*MATRIX EXAMPLE
**************************/
#define DATA PB3
#define WR   PB0
#define CS   PB6


extern struct MatrixDisplay theDisplay;
// use this line for single matrix(initialize the display attributes)
HT1632LEDMatrix1(DATA, WR, CS,-1);

// use this line for two matrices!
//HT1632LEDMatrix2(DATA, WR, CS, CS2,-1);


  displayBegin(HT1632_COMMON_16NMOS);  
  displayFillScreen();
  delay_ms(500);
  displayClearScreen(); 

while(1) {
  for (uint8_t y=0; y<theDisplay._height; y++) {
    for (uint8_t x=0; x< theDisplay._width; x++) {
      displaySetPixel(x, y);
      displayWriteScreen();
    }
  }
  // blink!
  displayBlink(true);
  delay_ms(2000);
  displayBlink(false);
  
  // Adjust the brightness down 
  for (int8_t i=15; i>=0; i--) {
   displaySetBrightness(i);
   delay_ms(100);
  }
  // then back up
  for (uint8_t i=0; i<16; i++) {
   displaySetBrightness(i);
   delay_ms(100);
  }

  for (uint8_t y=0; y<theDisplay._height; y++) {
    for (uint8_t x=0; x< theDisplay._width; x++) {
      displayClearPixel(x, y);
      displayWriteScreen();
    }
  }
}//end infinite while


/******************************
*SHAPES EXAMPLE
*******************************
#define DATA 2
#define WR   3
#define CS   4
#define CS2  5

// use this line for single matrix
HT1632LEDMatrix matrix = HT1632LEDMatrix(DATA, WR, CS);
// use this line for two matrices!
//HT1632LEDMatrix matrix = HT1632LEDMatrix(DATA, WR, CS, CS2);

void setup() {
  Serial.begin(9600);
  matrix.begin(HT1632_COMMON_16NMOS);  
  matrix.fillScreen();
  delay(500);

}

void loop() {
  matrix.clearScreen(); 
   // draw a pixel!
  matrix.drawPixel(0, 0, 1);
  matrix.writeScreen();
  
  delay(500);
   // clear a pixel!
  matrix.drawPixel(0, 0, 0); 
  matrix.writeScreen();
  
  // draw a big rect on the screen
  matrix.fillRect(matrix.width()/4, matrix.height()/4, 
                  matrix.width()/2, matrix.height()/2, 1);
  matrix.writeScreen();
  delay(500);

  // draw an outline
  matrix.drawRect(0, 0, matrix.width(), matrix.height(), 1);
  matrix.writeScreen();
  delay(500);
  
  // draw an 'X' in red
  matrix.clearScreen(); 
  matrix.drawLine(0, 0, matrix.width()-1, matrix.height()-1, 1);
  matrix.drawLine(matrix.width()-1, 0, 0, matrix.height()-1, 1);
  matrix.writeScreen();
  delay(500);

  // fill a circle
  matrix.fillCircle(matrix.width()/2-1, matrix.height()/2-1, 7, 1);
  matrix.writeScreen();
  delay_ms(500);

  // draw an inverted circle
  matrix.drawCircle(matrix.width()/2-1, matrix.height()/2-1, 4, 0);
  matrix.writeScreen();
  delay_ms(500);
  
  matrix.clearScreen(); 
  // draw some text!
  matrix.setTextSize(1);    // size 1 == 8 pixels high
  matrix.setTextColor(1);   // 'lit' LEDs

  if (matrix.width() <= 24) {
    matrix.setCursor(0, 0);   // start at top left, with one pixel of spacing
    matrix.print("Adaf ");
    matrix.setCursor(0, 8);   // next line, 8 pixels down
    matrix.print("ruit");
    matrix.writeScreen();
  } else if (matrix.width() > 24) {
    matrix.setCursor(0, 0);   // start at top left, with one pixel of spacing
    matrix.print("Adafruit");
    matrix.setCursor(0, 8);   // next line, 8 pixels down
    matrix.print("Industr.");
    matrix.writeScreen();
 }
  
  delay_ms_ms(2000);

  // whew!
}
*/

//free allocated memory
displayFreeMemory();

return 0;
}//end main
